#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <mem.h>

#define Base 0x378

#define PORT_DATA     Base    // Data register port 0x378        Pin 2-9

#define PORT_STAT     (Base+1)  // Status register port 0x379      Pin
#define ERROR         0x08   // 訡 ਭ                   15
#define SELECT        0x10   // ਭ on-line                   13
#define PE            0x20   // 1 - Paper end  -  㬠       12
#define ACK           0x40   // . ਥ ᨬ             10
#define BUSY          0x80   // ਭ  -   ! 11

#define PORT_CTRL     (Base+2)  // Ctrl register port 0x37a
#define DIRECTION_IN     0x20 // ࠢ 8 : 1 - 室, 0 - 室
#define ACK_ENABLE    0x10  // 1 - 襭 뢠 ਭ
#define SELECT_IN     0x08
#define INIT          0x04
#define AUTOFD        0x02
#define STROBE        0x01

#define DATAIN  outp(PORT_CTRL, (inp(PORT_CTRL) | 0x20) ) // set 8bit Data input
#define DATAOUT outp(PORT_CTRL, (inp(PORT_CTRL) & 0xdf) ) // set 8bit Data output

// EPP section
#define WRITE STROBE // 1
#define DATASTB AUTOFD //14
#define ADDRSTB SELECT_IN //17
#define RESET_ INIT
#define WAIT BUSY //11
#define INTR ACK  //10
#define ACKDATAREQ PE //12
#define XFLAG SELECT //13
#define DATAAVAIL ERROR //15


#define ERR_NOPRINTER 0x10
#define ERR_BADEXCHANGE 0x20

// printer commands
#define LTP_RESET  0
#define LTP_50MM_S 0x12
#define LTP_25MM_S 0x11
#define LTP_12MM_S 0x10

#define WORD unsigned short int
#define DWORD unsigned long int
#define LONG long int


/*

   while(!(inportb(PORT_STAT)&WAIT))
      if(count++ > 30){
         // reset exchange cycle
         outportb(PORT_CTRL, DATASTB | WRITE | RESET_);
         break;
         }
//   DATAOUT;
//   outportb(PORT_CTRL, WRITE | RESET_);
   outportb(PORT_DATA, byte);
   outportb(PORT_CTRL, DATASTB | WRITE | RESET_);
   count = 0;
   // wait until WAIT is set. If WAIT is set controller received the byte
   // (inportb(PORT_STAT)&WAIT) = 1 IF LEVEL IS 0 IN THE PORT!
   while((inportb(PORT_STAT)&WAIT))
      if(count++ > 30)
      {
         for(count = 0;count < 4;count++)
            outportb(PORT_CTRL, RESET_);
         break;
      }
   outportb(PORT_CTRL, RESET_);
   return 0;

*/


// bitmap section

typedef struct tagBITMAPFILEHEADER {
  WORD    bfType;
  DWORD   bfSize;
  WORD    bfReserved1;
  WORD    bfReserved2;
  DWORD   bfOffBits;
  } BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER{
  DWORD  biSize;
  LONG   biWidth;
  LONG   biHeight;
  WORD   biPlanes;
  WORD   biBitCount;
  DWORD  biCompression;
  DWORD  biSizeImage;
  LONG   biXPelsPerMeter;
  LONG   biYPelsPerMeter;
  DWORD  biClrUsed;
  DWORD  biClrImportant;
  } BITMAPINFOHEADER;

  BITMAPINFOHEADER bihdr;
  BITMAPFILEHEADER bfhdr;


int CurrLine=0;
unsigned char line[104];
int ColorOffset=0;
unsigned char ColorTable[8]; // rgbxrgbx

void GetBitmapInformation(FILE* file)
{
  fseek(file, 0, SEEK_SET);
  fread(&bfhdr, sizeof(BITMAPFILEHEADER), 1, file);
  fread(&bihdr, sizeof(BITMAPINFOHEADER), 1, file);

  ColorOffset = bihdr.biSize;
  fseek(file, ColorOffset + sizeof(BITMAPFILEHEADER), SEEK_SET);
  fread(&ColorTable, sizeof(char), 8, file);
}

void GetLine(FILE* file, int LineNo)
{
	fseek(file,  104*(79-LineNo), SEEK_SET);
   fread(line, 1, 104, file);
}

unsigned char CheckBitmap(void) // 1 if ok
{
	if(bihdr.biWidth > 832)
      return 0;
   if(bihdr.biHeight < 0)
   	bihdr.biHeight = -bihdr.biHeight;
   if(bihdr.biPlanes != 1)
   	return 0;
   if(bihdr.biBitCount != 1) // monochrome
   	return 0;
   if(bihdr.biCompression)
   	return 0;
   return 1;
}

/*
void ProcessLine(unsigned char*line, int len)
{
return;
for(int i=1;i<104;i+=2)
{
char b0 = line[i+1];
char b1 = line[i];
/ *char b2 = line[i+3];
char b3 = line[i];* /
line[i]=b0;
line[i+1]=b1;
//line[i+2]=b2;
//line[i+3]=b3;
}
}
*/

FILE* outf = NULL;

char blocks[13];

//unsigned char Packet[180];

int WaitDataStrobe(unsigned char StrobeValue, unsigned char Bit=INTR, int delay=200)
{
   int count = 0; //稪 প ⮢ 権  

   if(!StrobeValue)
      StrobeValue = Bit;
   else StrobeValue = 0;

   while((inportb(PORT_STAT)&Bit) == StrobeValue)
   {
      if(count++ > delay)
      {
         for(count = 0;count < 8;count++)
            outportb(PORT_CTRL, RESET_);
         return 1; //error
      }
   }

   return 0; // no error
}

void SendByteToPrinter(unsigned char byte)
{
   outportb(PORT_DATA, byte);
   outportb(PORT_CTRL, DATASTB | RESET_ | WRITE); //஡
   outportb(PORT_CTRL, DATASTB | RESET_ | WRITE);
   outportb(PORT_CTRL, DATASTB | RESET_ );
}

//ନ  뫠   
// return value = error
unsigned char SendPacket(unsigned char* data, int nBytes)
{
   unsigned char FreeBytes = 0; // get from printer
   unsigned char PrinterStatus = 0xff; // get from printer
   int nSent = 0; // count bytes actually sent to printer
//   int count = 0; //稪 প ⮢ 権  
   int BadPacket = 0; // ਧ 訡 । 
   int CountBadPackets = 0; // 稪 訡 ।
   int CountBadStrobes = 0;
//   Packet[PacketLen]=0x5a;

   while(nSent < nBytes)
   {
      // 뢠 ।饥 ﭨ ,   筮?
   	  outportb(PORT_CTRL, DIRECTION_IN | RESET_);

      //  ண    -       ,
      // ⮡   .

      for(int kk=0;kk<300;kk++) // delay 400 us
         inportb(PORT_DATA);

      if(CountBadPackets > 10)
         return ERR_NOPRINTER; // ਭ 

      disable();
      //ਬ ਭ,  ⨬   
      // । ⨬ ⠢    , .. ਭ 㤥 ᭠砫 । .

   	  outportb(PORT_CTRL, DATASTB | DIRECTION_IN | ADDRSTB | RESET_);
      // ADDRSTB -   ਬ ஫,    ᬥ ⠢   室

      //  ஡   ஫
//      count = 0;

      if(WaitDataStrobe(0, INTR, 500))
	  {
         enable();
         printf("  1  ஫(1)!\n");
		 fprintf(outf,"  1  ஫(1)!\n");
		 CountBadStrobes++;
	     continue; //,  ஡  
      }

      // get two bytes from printer: status and free_bytes
      PrinterStatus = inportb(PORT_DATA);

      if(PrinterStatus == 0xff) // 訡 ⥭   - - ᣫ稫
      {
         enable();
		 CountBadStrobes++;
         printf("訡 ⥭   378!\n");
		 fprintf(outf,"訡 ⥭   378!\n");
         break;
      }

      if(WaitDataStrobe(1))
	  {
         enable();
		 CountBadStrobes++;
         printf("  1  ஫(2)!\n");
		 fprintf(outf,"  1  ஫(2)!\n");
	     continue; //,  ஡  
      }

      if(WaitDataStrobe(0))
	  {
         enable();
		 CountBadStrobes++;
         printf("  2  ஫(3)!\n");
		 fprintf(outf,"  2  ஫(3)!\n");
	     continue; //,  ஡  
      }

      FreeBytes = inportb(PORT_DATA);

      if(WaitDataStrobe(1))
	  {
         enable();
		 CountBadStrobes++;
         printf("  2  ஫(4)!\n");
		 fprintf(outf,"  2  ஫(4)!\n");
	     continue; //,  ஡  
      }
      // ᫨ ஡ ,  ਭ ⮢ ਭ   ,
      //    ४   室

      //  ᪠ ஡ WAIT ->0 (1-஢७ ⭮, ⠬ )
      if(WaitDataStrobe(1, WAIT))
	  {
         enable();
		 CountBadStrobes++;
         printf(" ⮢ ஫  ਥ(5)!\n");
		 fprintf(outf," ⮢ ஫  ਥ(5)!\n");
	     continue; //,  ஡  
      }

   	  outportb(PORT_CTRL, DATASTB | RESET_);
      // ࠫ ADDRSTB - ᪠ ஫,  ४稫   室

      int nBytesToSend = nBytes-nSent;
	  if(nBytesToSend > FreeBytes-50)
         nBytesToSend = FreeBytes-50;
      if(nBytesToSend > 240)
         nBytesToSend = 240;
      if(PrinterStatus&0x0f) //  訡 ਭ -  ⠥!
         nBytesToSend = 0;
      if(FreeBytes < 50)
         nBytesToSend = 0;

      SendByteToPrinter(nBytesToSend+1);
      // ᭠砫 諥 ᫮ । ⮢  1 -  ᫥ ३ 

      for(int i = 0; i < nBytesToSend; i++)
      {
         SendByteToPrinter(data[nSent++]);//諥 ᮡ⢥ 
      }

      SendByteToPrinter(0x5a); //  

// ⢥  ஫,   襫 
      if(WaitDataStrobe(0))
         BadPacket = 1;

      //  ᨣ  室 ਭ  뢠
      // 0, ⮬   ᨨ (஢७  ⥬)
      // .. ,      1.
      if(WaitDataStrobe(0, WAIT))
         BadPacket = 1; //ਭ  襫  ﭨ ⥭ ⮢

      enable();

      for(i=0;i<12;i++)
         inportb(PORT_DATA);

      if(BadPacket)
      {
         //ਬ 横   ⨬ 稪 訡
         CountBadPackets++;
//         printf("訡 । !\n");
         if(CountBadPackets > 5)
            return ERR_BADEXCHANGE; // ਭ 
      }
      else CountBadPackets = 0;

      if(CountBadStrobes > 100)
      {
         printf("CountBadExchange = 100!\n");
		 fprintf(outf,"CountBadExchange = 100!\n");
         return ERR_BADEXCHANGE;
      }

      gotoxy(0, 25);

      printf("Status = %d\tFree FIFO bytes = %d\n", PrinterStatus, FreeBytes);
      fprintf(outf,"Status = %d\tFree FIFO bytes = %d\n", PrinterStatus, FreeBytes);

      if(FreeBytes == 0xff || PrinterStatus == 0xff)
         return ERR_BADEXCHANGE;

      if(FreeBytes < 140)
         delay(1); //    ᢮ 
   }

   return 0;
}

unsigned char SendLine(unsigned char *line)
{
   unsigned char SendArr[150], SendIdx = 0;

   SendArr[SendIdx++] = 'l';
   for(int i=0;i<13;i++)
      blocks[i]=0;
   unsigned char* b=blocks;
   int nbytes=0; // ᫮ , ࠡ⠭   
   for(i=103;i>=0;i--){
      register unsigned char v = line[i];
      SendArr[SendIdx++] = v;
      for(register char j=0;j<8;j++){
         if(v&1)
            (*b)++;
         v>>=1;
         }
      if(++nbytes>7){
         nbytes=0;
         b++;
         }
      }

#define NPIXELSTOPRINTINABLOCK 64
   //  ⢮ 祪   
   int ModuletoSelect=0; // ᫥騩   

   // 砥 㫨 ⠪, ⮡  㬬 ⠫
	//   NPIXELSTOPRINTINABLOCK 祪/

   fprintf(outf,"Pixels per block:\t");
   for(int kk=0;kk<13;kk++)
      fprintf(outf,"%d\t", blocks[kk]);
   fprintf(outf,"\n");

   int pixels = 0; // ᪮쪮 祪 㦥 㤥   ᫥饬 室

   fprintf(outf,"Mask:\t");

   while(ModuletoSelect < 13){
      unsigned int mask = 0;
      while( (blocks[ModuletoSelect] + pixels) <= NPIXELSTOPRINTINABLOCK){
         mask |= (1<<ModuletoSelect);
         pixels += blocks[ModuletoSelect];
         if(++ModuletoSelect > 13)
            break;
         }
//      ModuletoSelect++;

      if(pixels){ // ᫨ ப   
 		 SendArr[SendIdx++] = 's';
         SendArr[SendIdx++] = mask&0xff;
         SendArr[SendIdx++] = (mask>>8)&0xff;
         }
      fprintf(outf, "%X (%d)\t", mask, pixels);
      pixels = 0; // ⠫ -  㤥, ⠥  
      }

   fprintf(outf,"\n");

/*****    for(i=0;i<13;i++)
    {
    int mask = 1<<i;
			SendArr[SendIdx++] = 's';
         SendArr[SendIdx++] = mask&0xff;
         SendArr[SendIdx++] = (mask>>8)&0xff;
    } *****/

    unsigned char error =0;
    // ।,   ।  㤥 㫥, ..  

	error = SendPacket(SendArr, SendIdx);

	return error;
}


void main(int _argc, char*_argv[])
{
// test operation length
//for(unsigned long l = 0;l<1000000L;l++)
//   EppDataWrite(0xff); // nothing will be written

//printf("  , ᫨  祭  ਭ 室  뢠?\n");

   if(_argc != 2)
   {
   	printf("Program prints BMP files on printer LTP3445.\nPRINTBMP <filename.bmp>\n");
      return;
   }

	outf = fopen("fifo.txt", "wt");

   int end=0, num=99;
   while(num>0){
   char str[50];
   sprintf(str, "f%sp%03d.dat", _argv[1], num--);
	FILE* file = fopen(str, "rb");
   if(file==NULL){
      continue;
      }

//   GetBitmapInformation(file);
//   if(!CheckBitmap())
 //  {
  // 	printf("Could not print bitmap!\n");
   //   return;
//   }

   //   ,   SLCT  5.
//   outp(PORT_CTRL, (inp(PORT_CTRL))& (~SELECT_IN));

//   EppInit();

//   outportb(EPPDATA, 0); // begin printing
//   EppDataWrite(0);
   char ArraySetup[3];
   ArraySetup[0]=LTP_RESET; // reset printer
   ArraySetup[1]=LTP_25MM_S; // set speed

   SendPacket(ArraySetup, 2);

   int TotalErrors=0;
   for(int i=0;i<80;i++){
      GetLine(file, i);
//      ProcessLine(line, 104);
      int err = SendLine(line);
//      delay(50);
      if(err)
      {
      	printf("Error printing! (%d)", err);
        TotalErrors++;
         if(TotalErrors > 16)
	         break; /// error
         else i--; // 塞  ப
      }
   }

   fclose(file);
   }
   fclose(outf);
}